(ns sliva.server
  (:require [compojure.core :refer [defroutes GET]]
            [compojure.route :refer [resources]]
            [ring.util.response :refer [resource-response]]
            [ring.middleware.reload :refer [wrap-reload]]
            [chord.http-kit :refer [with-channel]]
            [org.httpkit.server :refer [run-server]]
            [clojure.core.async :refer [chan <! <!! >! put! close! go go-loop]]
            [clojure.string :as str]))

(defn socket-handler [request]
  (let [cid (java.util.UUID/randomUUID)]
    (with-channel request ws-ch
      (go
        (let [{:keys [message]} (<! ws-ch)]
          (println "new connection - " cid)
          (>! ws-ch (str "Hello " cid))
          (go-loop []
            (let [{:keys [message]} (<! ws-ch)]
              (println "GOT MSG!" message)
              (let [[cmd & args] (str/split message #":")]
                (println "command" cmd "(" args ")")
                (condp = cmd
                  "ping" (>! ws-ch "pong")

                  "Unknown command :/"))
              (recur))))))))
        ;;(close! ws-ch)))))

(defroutes routes
  (GET "/" [] (resource-response "index.html" {:root "public"}))
  (GET "/hello" [] "wat")
  (GET "/ws" [] socket-handler)
  (resources "/"))


(def handler (-> #'routes
                 wrap-reload))
